#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <sys/types.h>

int
main(int argc, char *argv[])
{
    if (argc != 4) {
	fprintf(stderr, "usage: fetch <hostname> <port> <file>\n");
	exit(1);
    }

    char *hostname = argv[1];
    int  port      = atoi(argv[2]);
    char *file     = argv[3];

    int fd = socket(AF_INET, SOCK_STREAM, 0); // SOCK_STREAM -> tcp
    assert(fd > -1);

    struct hostent *hp;
    hp = gethostbyname(hostname);
    assert(hp != NULL);

    struct sockaddr_in serveraddr;
    bzero((char *) &serveraddr, sizeof(serveraddr));
    serveraddr.sin_family = AF_INET;
    serveraddr.sin_port   = htons(port);
    bcopy((char *) hp->h_addr_list[0], 
	  (char *) &serveraddr.sin_addr.s_addr, hp->h_length);

    int rc = connect(fd, (struct sockaddr *) &serveraddr, 
		     sizeof(serveraddr));
    assert(rc == 0);

    // now write something
    char request[1000];
    sprintf(request, "GET /%s HTTP/1.0\r\n\r\n", file);
    rc = write(fd, request, strlen(request));

    char reply;
    while (1) {
	rc = read(fd, &reply, 1);
	if (rc == 0)
	    break;
	assert(rc != -1);
	if (reply == '\r')
	    printf("\\r");
	else if (reply == '\n')
	    printf("\\n\n");
	else 
	    printf("%c", reply);
    }

    close(fd);

    return 0;
}



